// ISO15693_ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ISO15693_Example.h"
#include "ISO15693_ExampleDlg.h"
#include "MasterRD.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define BAUD_NUMBER  7
const long BaudValue[BAUD_NUMBER] ={ 9600,14400,19200,28800,38400,57600,115200};
const CString BaudStr[BAUD_NUMBER] = { _T("9600"), _T("14400"), _T("19200"), _T("28800"), _T("38400"), _T("57600"), _T("115200")};

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CISO15693_ExampleDlg dialog

MainDlg::MainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(MainDlg::IDD, pParent)
	, m_hInst(NULL)
	, m_nReaderID(0)
	, m_nPort(1)
{
	//{{AFX_DATA_INIT(CISO15693_ExampleDlg)
	m_strUID = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	memset(m_cUID, 0, 8);
}

void MainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CISO15693_ExampleDlg)
	DDX_Control(pDX, IDC_COMBO_BLOCK, m_combBlock);
	DDX_Control(pDX, IDC_EDIT_DATA, m_hexeditData);
	DDX_Control(pDX, IDC_COMBO_RAUD, m_combBaud);
	DDX_Control(pDX, IDC_COMBO_PORT, m_combPort);
	DDX_Text(pDX, IDC_EDIT_ICDEV, m_nReaderID);
	DDX_Text(pDX, IDC_EDIT_UID, m_strUID);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(MainDlg, CDialog)
	//{{AFX_MSG_MAP(CISO15693_ExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_CBN_SELCHANGE(IDC_COMBO_PORT, OnSelchangeComboPortBaud)
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnButtonConnect)
	ON_BN_CLICKED(IDC_BTN_INVENTORY, OnBtnInventory)
	ON_BN_CLICKED(IDC_BTN_READ, OnBtnRead)
	ON_CBN_SELCHANGE(IDC_COMBO_RAUD, OnSelchangeComboPortBaud)
	ON_BN_CLICKED(IDC_BTN_WRITE, OnBtnWrite)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CISO15693_ExampleDlg message handlers

BOOL MainDlg::OnInitDialog()
{
	int i, state;
	CString strt;
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	MasterRD_Load_rfLib(&m_hInst);
	for (i = 0; i < BAUD_NUMBER; ++i)
	{
		m_combBaud.AddString(BaudStr[i]);
	}
	m_combBaud.SetCurSel(2);
	for (i = 1; i < 10; ++i)
	{
		strt.Format(_T("COM %d"), i);
		m_combPort.AddString(strt);
	}
	m_combPort.SetCurSel(0);
	m_nPort = 1;

	state = rf_COM_Open(1, 19200);
	
	if(state != LIB_SUCCESS)
	{
		rf_COM_Close(1);			
		MessageBox("Can't open reader!","Error",MB_OK|MB_ICONERROR);
		//return FALSE;
	}
	
	for (i = 0; i < 64; ++i)
	{
		strt.Format(_T("%d"), i);
		m_combBlock.AddString(strt);
	}
	m_combBlock.SetCurSel(0);
	m_hexeditData.SetLimitTextEx(4);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void MainDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void MainDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR MainDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void MainDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void MainDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void MainDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	if (m_hInst != NULL)
	{
		MasterRD_Free_rfLib(&m_hInst);
	}
	// TODO: Add your message handler code here
	
}

void MainDlg::OnButtonConnect() 
{
	UpdateData();
	CString str;
	int states = LIB_SUCCESS;
	states = rf_Reader_ComOpen(m_nPort, m_nReaderID);
	if (LIB_SUCCESS != states )	
	{
		if (LIB_READER_EXIST == states)
		{
			MessageBox(_T("The Reader has been Opened!"), _T("Error"), MB_OK|MB_ICONEXCLAMATION);
			return;
		}
		MessageBox(_T("rf_Reader_ComOpen Error"),_T("Error"),MB_OK|MB_ICONERROR);
		SetWindowText(_T("No Reader"));
		return;
	}
	str.Format(_T("Connected Reader %d @ COM%d"), m_nReaderID, m_nPort);
	SetWindowText(str);

	// öΪISO15693ģʽ
	rf_Reader_SetISOType(m_nReaderID, 0x31);
	rf_Reader_SetBeep(m_nReaderID, 5);
	rf_Reader_SetLight(m_nReaderID, 2);
}

void MainDlg::OnSelchangeComboPortBaud()
{

	int nBaud = BaudValue[m_combBaud.GetCurSel()];
	int nPort = m_combPort.GetCurSel() + 1;
	
	//close reader.
    rf_COM_Close(m_nPort);

	m_nPort = nPort;
	//reopen reader.
	int state = 1;	
    state = rf_COM_Open(nPort,nBaud);
	if(state != LIB_SUCCESS)
	{
		//rf_ClosePort(m_icdev);			
		MessageBox("Can't open reader!","Error",MB_OK|MB_ICONERROR);
		return ;
	}	
}

void MainDlg::Str2HexStr( CString &strHex, BYTE* pcInStr, int nLen )
{
	CString str;
	int i;
	for (i = 0; i < nLen; ++i)
	{
		str.Format(_T("%02X"), pcInStr[i]);
		strHex += str;
	}
}


void MainDlg::OnBtnInventory() 
{
	int nState;
	BYTE cBuf[256];
	BYTE cRetLen = 0;
	nState = rf_ISO15693_Inventory(m_nReaderID, cBuf, &cRetLen);
	if (nState == LIB_SUCCESS)
	{
		memcpy(m_cUID, &cBuf[1], 8);
		m_strUID.Empty();
		Str2HexStr(m_strUID, m_cUID, 8);
	}
	else
	{
		m_strUID.Empty();
		MessageBox(_T("rf_ISO15693_Inventory Error!"), _T("Error"));
	}
	rf_Reader_SetBeep(m_nReaderID, 5);
	rf_Reader_SetLight(m_nReaderID, 2);
	UpdateData(FALSE);
}

void MainDlg::OnBtnRead() 
{
	BYTE cBlock;
	BYTE cLen;
	int nState;
	BYTE cBuf[256];
	CString strData;
	cBlock = m_combBlock.GetCurSel();
	if (cBlock == -1)
	{
		cBlock = 0;
		m_combBlock.SetCurSel(0);
	}
	nState = rf_ISO15693_Read(m_nReaderID, 0x02, m_cUID, cBlock, 1, cBuf, &cLen);
	if (nState == LIB_SUCCESS)
	{
		Str2HexStr(strData, cBuf, cLen);
		m_hexeditData.SetWindowText(strData);
	}
	else
	{
		MessageBox(_T("rf_ISO15693_Read Error!"), _T("Error"));
	}
	rf_Reader_SetBeep(m_nReaderID, 5);
	rf_Reader_SetLight(m_nReaderID, 2);
}

void MainDlg::OnBtnWrite() 
{
	BYTE cBlock;
	int nState;
	BYTE cBuf[256];
	CString strData;
	BYTE cModel;
	cBlock = m_combBlock.GetCurSel();
	if (cBlock == -1)
	{
		cBlock = 0;
		m_combBlock.SetCurSel(0);
	}
	m_hexeditData.GetWindowTextEx(strData);
	if (strData.GetLength() != 4)
	{
		MessageBox(_T("Data Len Error!"), _T("Error"));
		return;
	}
	memcpy(cBuf, strData.GetBuffer(strData.GetLength()), 4);
	if (m_cUID[06] == 0x07)
	{
		cModel = 0x06;
	}
	else
	{
		cModel = 0x02;
	}
	nState = rf_ISO15693_Write(m_nReaderID, cModel, m_cUID, cBlock, cBuf);
	if (nState == LIB_SUCCESS)
	{

	}
	else
	{
		MessageBox(_T("rf_ISO15693_Write Error!"), _T("Error"));
	}
	rf_Reader_SetBeep(m_nReaderID, 5);
	rf_Reader_SetLight(m_nReaderID, 2);
}
