// MainDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MifareOneExample.h"
#include "MainDlg.h"

#include "masterrd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define BAUD_NUMBER  7
const long BaudValue[BAUD_NUMBER] ={ 9600,14400,19200,28800,38400,57600,115200};
const CString BaudStr[BAUD_NUMBER] = { _T("9600"), _T("14400"), _T("19200"), _T("28800"), _T("38400"), _T("57600"), _T("115200")};

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog

CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMainDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMainDlg)
	m_nReaderID = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nPort = 1;
	m_hInstMaster = NULL;
}

void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainDlg)
	DDX_Control(pDX, IDC_COMBO_MASS, m_combBlock);
	DDX_Control(pDX, IDC_COMBO_RAUD, m_combBaud);
	DDX_Control(pDX, IDC_COMBO_PORT, m_combPort);
	DDX_Control(pDX, IDC_EDIT_DATA, m_edit_data);
	DDX_Control(pDX, IDC_EDIT_KEY, m_edit_key);
	DDX_Control(pDX, IDC_EDIT_SERIAL, m_edit_serial);
	DDX_Text(pDX, IDC_EDIT_ICDEV, m_nReaderID);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	//{{AFX_MSG_MAP(CMainDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SEARCH, OnButtonSearch)
	ON_BN_CLICKED(IDC_BUTTON_READ, OnButtonRead)
	ON_BN_CLICKED(IDC_BUTTON_WRITE, OnButtonWrite)
	ON_BN_CLICKED(IDC_BUTTON_HALT, OnButtonHalt)
	ON_CBN_SELCHANGE(IDC_COMBO_PORT, OnSelchangeComboPortBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_RAUD, OnSelchangeComboPortBaud)
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnButtonConnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainDlg message handlers

BOOL CMainDlg::OnInitDialog()
{
	int i, state;
	CString strt;
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	///////////////////////////////
	//set edit length limit
	m_edit_key.SetLimitTextEx(6);
	UCHAR key[7] = "";
	m_edit_key.SetWindowTextEx(key, 6);
	m_edit_data.SetLimitTextEx(16);
	
	//Init comboData
	CString str;
	
	for(i = 0 ;i < 64;i++)
	{		
		str.Format(_T("%d"), i);
		m_combBlock.AddString( str);		
		m_combBlock.SetItemData(i, i);		
	} 
	m_combBlock.SetCurSel(0);
	//select keyA
	((CButton*)GetDlgItem(IDC_RADIO_KEYA))->SetCheck(TRUE);

	//load masterrd.dll to app
	if (!MasterRD_Load_rfLib(&m_hInstMaster))
	{
		return FALSE;
	}
	for (i = 0; i < BAUD_NUMBER; ++i)
	{
		m_combBaud.AddString(BaudStr[i]);
	}
	m_combBaud.SetCurSel(2);
	for (i = 1; i < 10; ++i)
	{
		strt.Format(_T("COM %d"), i);
		m_combPort.AddString(strt);
	}
	m_combPort.SetCurSel(0);
	m_nPort = 1;

	state = rf_COM_Open(1, 19200);
	
	if(state != LIB_SUCCESS)
	{
		rf_COM_Close(1);			
		MessageBox("Can't open reader!","Error",MB_OK|MB_ICONERROR);
		//return FALSE;
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMainDlg::OnPaint()  
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMainDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


BOOL CMainDlg::DestroyWindow() 
{
	if (m_hInstMaster)
	{
		MasterRD_Free_rfLib(&m_hInstMaster);	
	}
	return CDialog::DestroyWindow();
}

//************* find card **************//
void CMainDlg::OnButtonSearch() 
{
	int nStatus;
	unsigned char pcBuf[MAX_RF_BUFFER];
	unsigned char cLen;
	nStatus = rf_ISO14443A_GetCard(m_nReaderID, 0x52, pcBuf, &cLen);
	if(nStatus != LIB_SUCCESS)
	{
		m_edit_serial.SetWindowText("");
		return ;
	}
	m_edit_serial.SetWindowTextEx((pcBuf+3), cLen - 3);	
	rf_Reader_SetBeep(m_nReaderID, 5);
	rf_Reader_SetLight(m_nReaderID, 1);
}

//************* read *************//   
void CMainDlg::OnButtonRead() 
{
	BYTE cMode = 0x60;
	BYTE cBlock;
	int nState;
	CString strKey;	
	BYTE pcData[MAX_RF_BUFFER];

	CButton* pButton = (CButton*)GetDlgItem(IDC_RADIO_KEYA);
	if((pButton->GetCheck()))//KeyA
	{
		cMode = 0x60; 
	}
	else//KeyB
	{
		cMode = 0x61;
	}

	m_edit_key.GetWindowTextEx(strKey);
	if(m_edit_key.GetTextLenEx() != 6)
	{
		MessageBox(_T("please type 12 bytes key in keyarea"),_T("Error"),MB_OK|MB_ICONERROR);
		return ;
	}

	//selected blockNo.
	CComboBox *pCombBlock = (CComboBox*)GetDlgItem(IDC_COMBO_MASS);
	cBlock = (BYTE)pCombBlock->GetCurSel();

	//auth sector use key.

	nState = rf_M1_Authentication(m_nReaderID, cMode, cBlock, (BYTE*)strKey.GetBuffer(strKey.GetLength()));
	strKey.ReleaseBuffer();

	if(nState != LIB_SUCCESS)
	{
		MessageBox(_T("rf_M1_Authentication Error"),_T("Error"),MB_OK|MB_ICONERROR);
		m_edit_data.SetWindowText("");
		return;	
	}

	//read Mifare One card a block data.
	nState = rf_M1_Read(m_nReaderID, cBlock, pcData);
	if(nState)
	{
		MessageBox(_T("M1_read Error"),_T("Error"),MB_OK|MB_ICONERROR);
		m_edit_data.SetWindowText("");
		return;	
	}

	m_edit_data.SetWindowTextEx(pcData,16);

	rf_Reader_SetBeep(m_nReaderID, 5);
	rf_Reader_SetLight(m_nReaderID, 2);
}

//************* Write *************//
void CMainDlg::OnButtonWrite() 
{
	//WORD icdev = 0x0000;
	unsigned char mode = 0x60;
	unsigned char secnr = 0x00;
	int state;
	CString strKey,strEdit;	
	unsigned char Data[16];	

	CButton* pButton = (CButton*)GetDlgItem(IDC_RADIO_KEYA);
	if((pButton->GetCheck()))//KeyA
	{
		mode = 0x60; 
	}
	else//KeyB
	{
		mode = 0x61; //
	}

	m_edit_key.GetWindowTextEx(strKey);
	if(m_edit_key.GetTextLenEx() != 6)
	{
		MessageBox(_T("Please type 16 bytes key in keyarea"),_T("Error"),MB_OK|MB_ICONERROR);
		return ;
	}

	//sector No
	CComboBox *pCBB = (CComboBox*)GetDlgItem(IDC_COMBO_MASS);
	int nSel = pCBB->GetCurSel();
	secnr = (unsigned char)(pCBB->GetItemData(nSel));	
	
	
	//======================
	//auth sector.
	state = rf_M1_Authentication(m_nReaderID,mode,(secnr/4)*4,(unsigned char*)strKey.GetBuffer(strKey.GetLength()));
	if(state)
	{
		MessageBox(_T("M1_authentication2 Error"),_T("Error"),MB_OK|MB_ICONERROR);
		return;	
	}

	//data for write
	m_edit_data.GetWindowTextEx(strEdit);			
	memcpy(Data,strEdit.GetBuffer(strEdit.GetLength()),strEdit.GetLength());
	//write data 
	state = rf_M1_Write(m_nReaderID,secnr,Data);
	if(state)
	{
		MessageBox(_T("M1_write"),_T("Error"),MB_OK|MB_ICONERROR);
		return;	
	}
	rf_Reader_SetBeep(m_nReaderID, 5);
	rf_Reader_SetLight(m_nReaderID, 1);
}

//************* halt *************//
void CMainDlg::OnButtonHalt() 
{
	//WORD icdev = 0x0000;
	int state;

	state = rf_ISO14443A_Halt(m_nReaderID);
	if(state)
	{
		MessageBox(_T("rf_halt Error"),_T("Error"),MB_OK|MB_ICONERROR);
	}	
}


void CMainDlg::OnSelchangeComboPortBaud()
{

	int nBaud = BaudValue[m_combBaud.GetCurSel()];
	int nPort = m_combPort.GetCurSel() + 1;
	
	//close reader.
    rf_COM_Close(m_nPort);

	m_nPort = nPort;
	//reopen reader.
	int state = 1;	
    state = rf_COM_Open(nPort,nBaud);
	if(state < LIB_SUCCESS)
	{
		//rf_ClosePort(m_icdev);			
		MessageBox("can't open reader!","Error",MB_OK|MB_ICONERROR);
		return ;
	}	
}

void CMainDlg::OnButtonConnect() 
{
	UpdateData();
	CString str;
	int states = LIB_SUCCESS;
	states = rf_Reader_ComOpen(m_nPort, m_nReaderID);
	if (LIB_SUCCESS != states )	
	{
		if (LIB_READER_EXIST == states)
		{
			MessageBox(_T("The Reader has been Opened!"), _T("Error"), MB_OK|MB_ICONEXCLAMATION);
			return;
		}
		MessageBox(_T("rf_Reader_ComOpen Error"),_T("Error"),MB_OK|MB_ICONERROR);
		SetWindowText(_T("No Reader"));
		return;
	}
	str.Format(_T("Connected Reader %d @ COM%d"), m_nReaderID, m_nPort);
	SetWindowText(str);
	rf_Reader_SetBeep(m_nReaderID, 5);
	rf_Reader_SetLight(m_nReaderID, 2);
}
