// SAM_ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SAM_Example.h"
#include "SAM_ExampleDlg.h"
#include "MasterRD.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define BAUD_NUMBER  7
const long BaudValue[BAUD_NUMBER] ={ 9600,14400,19200,28800,38400,57600,115200};
const long SAM_BaudValue[7] ={9600, 19200, 38400, 55800, 57600, 115200, 230400};
const CString BaudStr[BAUD_NUMBER] = { _T("9600"), _T("14400"), _T("19200"), _T("28800"), _T("38400"), _T("57600"), _T("115200")};
/////////////////////////////////////////////////////////////////////////////
// MainDlg dialog

MainDlg::MainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(MainDlg::IDD, pParent)
	, m_hInst(NULL)
	, m_nReaderID(0)
	, m_nPort(1)
{
	//{{AFX_DATA_INIT(MainDlg)
	m_strRSTInfo = _T("");
	m_strRetInfo = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void MainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MainDlg)
	DDX_Control(pDX, IDC_EDIT_INFO, m_editRetInfo);
	DDX_Control(pDX, IDC_EDIT_RST_INFO, m_hexeditRSTInfo);
	DDX_Control(pDX, IDC_EDIT_CMD, m_hexeditCMD);
	DDX_Control(pDX, IDC_COMBO_SAM_BAUD, m_combSamBaud);
	DDX_Control(pDX, IDC_COMBO_RAUD, m_combBaud);
	DDX_Control(pDX, IDC_COMBO_PORT, m_combPort);
	DDX_Text(pDX, IDC_EDIT_ICDEV, m_nReaderID);
	DDX_Text(pDX, IDC_EDIT_RST_INFO, m_strRSTInfo);
	DDX_Text(pDX, IDC_EDIT_INFO, m_strRetInfo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(MainDlg, CDialog)
	//{{AFX_MSG_MAP(MainDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_CBN_SELCHANGE(IDC_COMBO_PORT, OnSelchangeComboPortBaud)
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnButtonConnect)
	ON_BN_CLICKED(IDC_BTN_SETPPS, OnBtnSetpps)
	ON_BN_CLICKED(IDC_BTN_SAM_RST, OnBtnSamRst)
	ON_CBN_SELCHANGE(IDC_COMBO_RAUD, OnSelchangeComboPortBaud)
	ON_BN_CLICKED(IDC_BTN_SAM_COS, OnBtnSamCos)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MainDlg message handlers

BOOL MainDlg::OnInitDialog()
{
	int i, state;
	CString strt;
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	MasterRD_Load_rfLib(&m_hInst);
	for (i = 0; i < BAUD_NUMBER; ++i)
	{
		m_combBaud.AddString(BaudStr[i]);
	}
	m_combBaud.SetCurSel(2);
	for (i = 1; i < 10; ++i)
	{
		strt.Format(_T("COM %d"), i);
		m_combPort.AddString(strt);
	}
	m_combPort.SetCurSel(0);

	for (i = 0; i < 7; ++i)
	{
		strt.Format(_T("%d"), SAM_BaudValue[i]);
		m_combSamBaud.AddString(strt);
	}
	m_combSamBaud.SetCurSel(0);

	m_nPort = 1;

	state = rf_COM_Open(1, 19200);
	
	if(state != LIB_SUCCESS)
	{
		rf_COM_Close(1);			
		MessageBox("Can't open reader!","Error",MB_OK|MB_ICONERROR);
		//return FALSE;
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void MainDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR MainDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void MainDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void MainDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void MainDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	if (m_hInst != NULL)
	{
		MasterRD_Free_rfLib(&m_hInst);
	}
	// TODO: Add your message handler code here
	
}

void MainDlg::OnButtonConnect() 
{
	UpdateData();
	CString str;
	int states = LIB_SUCCESS;
	states = rf_Reader_ComOpen(m_nPort, m_nReaderID);
	if (LIB_SUCCESS != states )	
	{
		if (LIB_READER_EXIST == states)
		{
			MessageBox(_T("The Reader has been Opened!"), _T("Error"), MB_OK|MB_ICONEXCLAMATION);
			return;
		}
		MessageBox(_T("rf_Reader_ComOpen Error"),_T("Error"),MB_OK|MB_ICONERROR);
		SetWindowText(_T("No Reader"));
		return;
	}
	str.Format(_T("Connected Reader %d @ COM%d"), m_nReaderID, m_nPort);
	SetWindowText(str);

	// öΪISO15693ģʽ
	rf_Reader_SetISOType(m_nReaderID, 0x31);
	rf_Reader_SetBeep(m_nReaderID, 5);
	rf_Reader_SetLight(m_nReaderID, 2);
}

void MainDlg::OnSelchangeComboPortBaud()
{

	int nBaud = BaudValue[m_combBaud.GetCurSel()];
	int nPort = m_combPort.GetCurSel() + 1;
	
	//close reader.
    rf_COM_Close(m_nPort);

	m_nPort = nPort;
	//reopen reader.
	int state = 1;	
    state = rf_COM_Open(nPort,nBaud);
	if(state != LIB_SUCCESS)
	{
		//rf_ClosePort(m_icdev);			
		MessageBox("Can't open reader!","Error",MB_OK|MB_ICONERROR);
		return ;
	}	
}

void MainDlg::Str2HexStr( CString &strHex, BYTE* pcInStr, int nLen )
{
	CString str;
	int i;
	for (i = 0; i < nLen; ++i)
	{
		str.Format(_T("%02X"), pcInStr[i]);
		strHex += str;
	}
}



void MainDlg::OnBtnSamRst() 
{
	int nState;
	BYTE pcBuf[512];
	BYTE cLen = 0;
	if (!rf_Reader_IsOpen(m_nReaderID))
	{
		MessageBox(_T("Please Connect a Reader first!"), _T("Err"));
		return;
	}
	UpdateData();

	nState = rf_SAM_InitBaudrate(m_nReaderID, 1, 9600);
	if (nState != LIB_SUCCESS)
	{
		m_strRetInfo += _T("rf_SAM_InitBaudrate Error!");
		m_strRetInfo += _T("\r\n");
		m_strRSTInfo.Empty();
		UpdateData(FALSE);
		m_editRetInfo.SetSel(m_strRetInfo.GetLength(), m_strRetInfo.GetLength());
		return;
	}
	nState = rf_SAM_RST(m_nReaderID, 1, pcBuf, &cLen);
	if (nState != LIB_SUCCESS)
	{
		m_strRetInfo += _T("rf_SAM_RST Error!");
		m_strRetInfo += _T("\r\n");
		m_strRSTInfo.Empty();
		UpdateData(FALSE);
		m_editRetInfo.SetSel(m_strRetInfo.GetLength(), m_strRetInfo.GetLength());
		return;
	}
	m_strRSTInfo.Empty();
	Str2HexStr(m_strRSTInfo, pcBuf, cLen);
	UpdateData(FALSE);
	rf_Reader_SetBeep(m_nReaderID, 5);
	rf_Reader_SetLight(m_nReaderID, 1);
}


void MainDlg::OnBtnSetpps() 
{
	int nState;
	if (!rf_Reader_IsOpen(m_nReaderID))
	{
		MessageBox(_T("Please Connect a Reader first!"), _T("Err"));
		return;
	}
	UpdateData();
	
	int nBaudSel;
	nBaudSel = m_combSamBaud.GetCurSel();

	nState = rf_SAM_SetPPS(m_nReaderID, 1, SAM_BaudValue[nBaudSel]);
	if (nState != LIB_SUCCESS)
	{
		m_strRetInfo += _T("rf_SAM_SetPPS Error!");
	}
	else
	{
		m_strRetInfo += _T("rf_SAM_SetPPS Success!");
	}
	m_strRetInfo += _T("\r\n");
	UpdateData(FALSE);
	m_editRetInfo.SetSel(m_strRetInfo.GetLength(), m_strRetInfo.GetLength());
}


void MainDlg::OnBtnSamCos() 
{
	int nState;
	BYTE pcBuf[512];
	BYTE cLen = 0;
	if (!rf_Reader_IsOpen(m_nReaderID))
	{
		MessageBox(_T("Please Connect a Reader first!"), _T("Err"));
		return;
	}
	UpdateData();
	
	CString strCMD;
	m_hexeditCMD.GetWindowTextEx(strCMD);
	if (strCMD.IsEmpty())
	{
		MessageBox(_T("COS CMD is empty!"));
		return;
	}


	nState = rf_SAM_COS(m_nReaderID, 1, (BYTE*)strCMD.GetBuffer(strCMD.GetLength()), strCMD.GetLength(), pcBuf, &cLen, 2000);

	if (nState != LIB_SUCCESS)
	{
		m_strRetInfo += _T("rf_SAM_COS Error!");
	}
	else
	{
		Str2HexStr(m_strRetInfo, pcBuf, cLen);
	}
	m_strRetInfo += _T("\r\n");
	UpdateData(FALSE);
	m_editRetInfo.SetSel(m_strRetInfo.GetLength(), m_strRetInfo.GetLength());
	rf_Reader_SetBeep(m_nReaderID, 5);
	rf_Reader_SetLight(m_nReaderID, 2);
}
