// Reader.cpp : Implementation of CReader

#include "stdafx.h"
#include "Reader.h"
#include <comdef.h>
#include <atlconv.h>
#include "MasterRD.h"


static void Byte2StrHex( BYTE *argBufDst, BYTE *argBufSrc, DWORD argLgBufSrc, BOOL addCarNull )
{
	BYTE	hiByte;
	BYTE	loByte;

	for ( ; argLgBufSrc > 0; argLgBufSrc-- )
	{
		hiByte = (*argBufSrc >> 4) & 0x0F;
		loByte = *(argBufSrc++) & 0x0F;

		*(argBufDst++) = (hiByte < 10) ? '0'+hiByte : 'A'-10+hiByte;
		*(argBufDst++) = (loByte < 10) ? '0'+loByte : 'A'-10+loByte;
	}

	if ( addCarNull )
		*argBufDst = '\0';
}

static void StrHex2Byte( BYTE *argBufDst, BYTE *argBufSrc, DWORD argLgBufSrc )
{

	BYTE	hiByte;
	BYTE	loByte;

	BYTE   *pDstBuf=argBufDst;
	BYTE   *pSrcBuf=argBufSrc;


	for ( ; argLgBufSrc > 0; argLgBufSrc -= 2 )
	{
		hiByte = *(argBufSrc++);
		loByte = *(argBufSrc++);
		*(argBufDst++) = (((hiByte >= '0' && hiByte <= '9') ? hiByte - '0' :
			(hiByte >= 'A' && hiByte <= 'F') ? hiByte - 'A'+10 :
			(hiByte >= 'a' && hiByte <= 'f') ? hiByte - 'a'+10 : 0) << 4 ) |
			((loByte >= '0' && loByte <= '9') ? loByte - '0' :
			(loByte >= 'A' && loByte <= 'F') ? loByte - 'A'+10 :
			(loByte >= 'a' && loByte <= 'f') ? loByte - 'a'+10 : 0);
	}
}

/*
BYTE blockData[33];
Byte2StrHex(blockData,(BYTE*)m_blockData,16,TRUE);
USES_CONVERSION;
LPWSTR wBuf =A2W((LPCSTR)blockData);
//wcsncpy(*pVal,wBuf,32);
* pVal = SysAllocStringLen(wBuf,32);
return S_OK;

WCHAR wBuf[33]={0};
int len=SysStringLen(newVal);
if(len > 32) len=32;
wcsncpy(wBuf,newVal,len);
USES_CONVERSION;
LPSTR aBuf= W2A(wBuf);
len = strlen(aBuf);
memset(m_blockData,0,sizeof(m_blockData));
StrHex2Byte((BYTE*)m_blockData,(BYTE*)aBuf,len);
return S_OK;

*/



// CReader

STDMETHODIMP CReader::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IReader
	};

	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

HRESULT CReader::FinalConstruct()
{
	if(MasterRD_Load_rfLib())
		return S_OK;
	else
		return S_FALSE;
}

void CReader::FinalRelease()
{
	MasterRD_Free_rfLib();
}


HRESULT GetValue(IDispatch* pDisp, int index, int *value)
{
	CComVariant varName(index, VT_I4);
	DISPID dispId;
	varName.ChangeType(VT_BSTR); // ±תΪͣԽGetIDsOfNames
	HRESULT hr = pDisp->GetIDsOfNames(IID_NULL, &varName.bstrVal, 1, LOCALE_USER_DEFAULT, &dispId);
	if (FAILED(hr)) 
		return hr;

	DISPPARAMS noArgs = {NULL, NULL, 0, 0};
	VARIANT varVal;
	hr = pDisp->Invoke(dispId, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_PROPERTYGET , &noArgs, &varVal, NULL, NULL);
	if(varVal.vt == VT_I4)
	{
		*value = varVal.intVal;
	}else
	{
		hr = S_FALSE;
	}
	return hr;
}

HRESULT GetValue(IDispatch* pDisp, int index, char *value,int buflen)
{
	CComVariant varName(index, VT_I4);
	DISPID dispId;
	varName.ChangeType(VT_BSTR); // ±תΪͣԽGetIDsOfNames
	HRESULT hr = pDisp->GetIDsOfNames(IID_NULL, &varName.bstrVal, 1, LOCALE_USER_DEFAULT, &dispId);
	if (FAILED(hr)) 
		return hr;

	DISPPARAMS noArgs = {NULL, NULL, 0, 0};
	VARIANT varVal;
	hr = pDisp->Invoke(dispId, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_PROPERTYGET , &noArgs, &varVal, NULL, NULL);
	if(varVal.vt == VT_BSTR)
	{
		USES_CONVERSION;
		LPSTR aBuf= W2A(varVal.bstrVal);
		strncpy(value,aBuf,buflen);
	}else
	{
		hr = S_FALSE;
	}
	return hr;
}
HRESULT GetValue(IDispatch* pDisp, int index, WCHAR *value,int buflen)
{
	CComVariant varName(index, VT_I4);
	DISPID dispId;
	varName.ChangeType(VT_BSTR); // ±תΪͣԽGetIDsOfNames
	HRESULT hr = pDisp->GetIDsOfNames(IID_NULL, &varName.bstrVal, 1, LOCALE_USER_DEFAULT, &dispId);
	if (FAILED(hr)) 
		return hr;

	DISPPARAMS noArgs = {NULL, NULL, 0, 0};
	VARIANT varVal;
	hr = pDisp->Invoke(dispId, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_PROPERTYGET , &noArgs, &varVal, NULL, NULL);
	if(varVal.vt == VT_BSTR)
	{
		wcsncpy(value,varVal.bstrVal,buflen);
	}else
	{
		hr = S_FALSE;
	}
	return hr;
}


HRESULT SetValue(IDispatch* pDisp, int index, int value)
{
	CComVariant varName(index, VT_I4);
	DISPID dispId;
	CComVariant varValue;
	HRESULT hr = 0;
	varName.ChangeType(VT_BSTR); // ±תΪͣԽGetIDsOfNames
	hr = pDisp->GetIDsOfNames(IID_NULL, &varName.bstrVal, 1, LOCALE_USER_DEFAULT, &dispId);
	if (FAILED(hr)) 
		return hr;

	DISPID dispidPut = DISPID_PROPERTYPUT; // put
	DISPPARAMS dispparams;
	dispparams.rgvarg = new VARIANTARG[1]; // ʼrgvarg
	dispparams.rgvarg[0].vt = VT_I4; // 
	dispparams.rgvarg[0].intVal = value; // ֵ
	dispparams.cArgs = 1; // 
	dispparams.cNamedArgs = 1; // 
	dispparams.rgdispidNamedArgs = &dispidPut; // DispIdput

	hr = pDisp->Invoke(dispId, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_PROPERTYPUT, &dispparams, NULL, NULL, NULL);
	return hr;

}

HRESULT SetValue(IDispatch* pDisp, int index, WCHAR * value)
{
	CComVariant varName(index, VT_I4);
	DISPID dispId;
	CComVariant varValue;
	HRESULT hr = 0;
	varName.ChangeType(VT_BSTR); // ±תΪͣԽGetIDsOfNames
	hr = pDisp->GetIDsOfNames(IID_NULL, &varName.bstrVal, 1, LOCALE_USER_DEFAULT, &dispId);
	if (FAILED(hr)) 
		return hr;

	//DISPPARAMS noArgs = {NULL, NULL, 0, 0};
	//VARIANT varVal;
	//hr = pDisp->Invoke(dispId, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_PROPERTYGET , &noArgs, &varVal, NULL, NULL);
	int    wLen = SysStringLen(value);

	BSTR result = SysAllocStringLen(value, wLen);

	DISPID dispidPut = DISPID_PROPERTYPUT; // put
	DISPPARAMS dispparams;
	dispparams.rgvarg = new VARIANTARG[1]; // ʼrgvarg
	dispparams.rgvarg[0].vt = VT_BSTR; // 
	dispparams.rgvarg[0].bstrVal =  result;//value; // ֵ
	dispparams.cArgs = 1; // 
	dispparams.cNamedArgs = 1; // 
	dispparams.rgdispidNamedArgs = &dispidPut; // DispIdput

	hr = pDisp->Invoke(dispId, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_PROPERTYPUT, &dispparams, NULL, NULL, NULL);
	return hr;
}

HRESULT SetValue(IDispatch* pDisp, int index, char * value)
{
	CComVariant varName(index, VT_I4);
	DISPID dispId;
	CComVariant varValue;
	HRESULT hr = 0;
	varName.ChangeType(VT_BSTR); // ±תΪͣԽGetIDsOfNames
	hr = pDisp->GetIDsOfNames(IID_NULL, &varName.bstrVal, 1, LOCALE_USER_DEFAULT, &dispId);
	if (FAILED(hr)) 
		return hr;

	//DISPPARAMS noArgs = {NULL, NULL, 0, 0};
	//VARIANT varVal;
	//hr = pDisp->Invoke(dispId, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_PROPERTYGET , &noArgs, &varVal, NULL, NULL);
	USES_CONVERSION;
	LPWSTR wBuf = A2W((LPCSTR)value);
	int    wLen = wcslen(wBuf);

	BSTR result = SysAllocStringLen(wBuf, wLen);
	
	DISPID dispidPut = DISPID_PROPERTYPUT; // put
	DISPPARAMS dispparams;
	dispparams.rgvarg = new VARIANTARG[1]; // ʼrgvarg
	dispparams.rgvarg[0].vt = VT_BSTR; // 
	dispparams.rgvarg[0].bstrVal =  result;//value; // ֵ
	dispparams.cArgs = 1; // 
	dispparams.cNamedArgs = 1; // 
	dispparams.rgdispidNamedArgs = &dispidPut; // DispIdput

	hr = pDisp->Invoke(dispId, IID_NULL, LOCALE_USER_DEFAULT, DISPATCH_PROPERTYPUT, &dispparams, NULL, NULL, NULL);
	return hr;
}

BOOL IsJSArrayType(IDispatch * pDisp,int * arraylen)
{
	//߱push߱lengthԵĶӦþһ Javascriptе Arrayˡ
	CComBSTR pushName(L"push");
	DISPID dispId;
	HRESULT hr = pDisp->GetIDsOfNames(IID_NULL, &pushName, 1, LOCALE_USER_DEFAULT, &dispId);
	if (FAILED(hr))
		return FALSE;
	CComBSTR lenName(L"length");
	hr = pDisp->GetIDsOfNames(IID_NULL,&lenName,1,LOCALE_USER_DEFAULT,&dispId);
	if(FAILED(hr))
		return FALSE;

	DISPPARAMS noArgs = {NULL, NULL, 0, 0};
	VARIANT varVal;
	hr = pDisp->Invoke(dispId, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_PROPERTYGET , &noArgs, &varVal, NULL, NULL);
	if(FAILED(hr))
		return FALSE;

	*arraylen = varVal.intVal;
	return TRUE;

}

#define cRdrConfig		100
#define cRdrsetup		101
#define cRdrOpen		102
#define cRdrClose       103
#define cRdrM1Read      104
#define cRdrM1Write     105
#define cRdrM1LoadKey   106
#define cRdrM1GetCard   107
#define cRdrM1Authentication 108
#define cRdrGetCfg	109
#define cRdrSetCfg  110

STDMETHODIMP CReader::DoReader(ULONG opcode,VARIANT p, LONG* retval)
{
	// TODO: Add your implementation code here
	//鳤ȣԪص
	*retval = LIB_PARAM_ERR; //default param error.
	
	//javascriptУ var para = new Array(RdrId,BlockId,'BlockData')ʽݲ
	int arlen=0;
	if(p.vt == VT_DISPATCH && IsJSArrayType(p.pdispVal,&arlen))
	{
		IDispatch * pDisp= p.pdispVal;
		//SetValue(pDisp,1,999);
		//SetValue(pDisp,2,"fffffff");

		int ret = LIB_SUCCESS;

		switch(opcode)
		{
		case cRdrGetCfg:
			{
				//new Array(RdrType<com:1,net:2>, ComPort,Baud, IpAddr,TcpPort,ReaderId);
				//para[0] 0עУûĿǵһʹãҪʾһԻûѡز 0Ч1ڣ2
				//ԻʹߣHtmlԻʾûѡ

				CRegKey reg;
				DWORD   tmp=0;
				reg.Create(HKEY_CURRENT_USER,_T("Software\\iCscReader"));
				if(ERROR_SUCCESS == reg.QueryDWORDValue(_T("RdrType"),tmp))
					SetValue(pDisp,0,tmp);
				if(ERROR_SUCCESS == reg.QueryDWORDValue(_T("ComPort"),tmp))
					SetValue(pDisp,1,tmp);
				if(ERROR_SUCCESS == reg.QueryDWORDValue(_T("Baud"),tmp))
					SetValue(pDisp,2,tmp);

				TCHAR IpAddr[32]={0};
				ULONG IpAddrLen=0;
				if(ERROR_SUCCESS == reg.QueryStringValue(_T("IpAddr"),IpAddr,&IpAddrLen))
				{
					SetValue(pDisp,3,IpAddr);
				}
				if(ERROR_SUCCESS == reg.QueryDWORDValue(_T("TcpPort"),tmp))
					SetValue(pDisp,4,tmp);

				if(ERROR_SUCCESS == reg.QueryDWORDValue(_T("ReaderId"),tmp))
					SetValue(pDisp,5,tmp);

				ret = LIB_SUCCESS;

			}
			break;
		case cRdrSetCfg:
			{
				CRegKey reg;
				reg.Create(HKEY_CURRENT_USER,_T("Software\\iCscReader"));
				int tmp;
				GetValue(pDisp,0,&tmp);
				reg.SetDWORDValue(_T("RdrType"),tmp);
				GetValue(pDisp,1,&tmp);
				reg.SetDWORDValue(_T("ComPort"),tmp);
				GetValue(pDisp,2,&tmp);
				reg.SetDWORDValue(_T("Baud"),tmp);
				
				TCHAR IpAddr[32]={0};
				GetValue(pDisp,3,IpAddr,32);
				reg.SetStringValue(_T("IpAddr"), IpAddr);

				GetValue(pDisp,4,&tmp);
				reg.SetDWORDValue(_T("TcpPort"),tmp);
				GetValue(pDisp,5,&tmp);
				reg.SetDWORDValue(_T("ReaderId"),tmp);
				ret = LIB_SUCCESS;

			}break;
		case cRdrOpen:
			{
				int port=2;
				int baud= 19200;
				WORD ReaderId=0;
				GetValue(pDisp,0,&port);
				GetValue(pDisp,1,&baud);
				int tmp;
				GetValue(pDisp,2,&tmp);
				ReaderId = tmp;

				ret=rf_COM_Open(port,baud);
				if(ret == LIB_SUCCESS) 
				{
					ret =rf_Reader_ComOpen(port,ReaderId);
				}
			}
			break;
		case cRdrConfig: 
			if(arlen != 3)
			{
				*retval = 8;
			}

			break;
		case cRdrM1GetCard:
			{
				WORD ReaderId=0;
				BYTE cMode = 0x52;
				BYTE Cardbuf[12];
				BYTE cLen=0;

				int tmp;
				GetValue(pDisp,0,&tmp);
				ReaderId = tmp;
				GetValue(pDisp,1,&tmp);
				cMode = tmp;
				

				ret=rf_ISO14443A_GetCard(ReaderId,cMode,Cardbuf,&cLen);

				char hexbuf[24];
				Byte2StrHex((BYTE*)hexbuf,Cardbuf,cLen,TRUE);
				SetValue(pDisp,2,hexbuf);
				SetValue(pDisp,3,cLen*2);
			}
			break;
		case cRdrM1Authentication:
			{
				WORD ReaderId=0;
				BYTE cMode = 0x60; //keyA
				BYTE keyData[6] = { 0xff,0xff,0xff,0xff,0xff,0xff};
				BYTE cBlock  = 4;

				int tmp;
				GetValue(pDisp,0,&tmp);
				ReaderId=tmp;
				GetValue(pDisp,1,&tmp);
				cMode = tmp;
				GetValue(pDisp,2,&tmp);
				cBlock = tmp;
				char hexbuf[16];
				GetValue(pDisp,3,hexbuf,16);
				StrHex2Byte(keyData,(BYTE*)hexbuf,12);
				ret = rf_M1_Authentication(ReaderId,cMode,cBlock,keyData);
			}
			break;

		case cRdrM1Read:
			{
				WORD ReaderId= 0;
				BYTE cBlock  = 4;
				BYTE blockData[16];

				int tmp;
				GetValue(pDisp,0,&tmp);
				ReaderId=tmp;
				GetValue(pDisp,1,&tmp);
				cBlock= tmp;
				ret = rf_M1_Read(ReaderId,cBlock,blockData);
				if(ret == LIB_SUCCESS)
				{
					char hexbuf[33];
					Byte2StrHex((BYTE*)hexbuf,blockData,16,TRUE);
					SetValue(pDisp,2,hexbuf);
				}
			}
			break;
		case cRdrM1Write:
			{
				WORD ReaderId= 0;
				BYTE cBlock  = 4;
				BYTE blockData[16];

				int tmp;
				GetValue(pDisp,0,&tmp);
				ReaderId=tmp;
				GetValue(pDisp,1,&tmp);
				cBlock= tmp;

				char hexbuf[33];
				GetValue(pDisp,2,hexbuf,32);
				StrHex2Byte(blockData,(BYTE*)hexbuf,32);
				ret = rf_M1_Write(ReaderId,cBlock,blockData);
			}
			break;
		case cRdrClose:
			{

			}
			break;
		}

		*retval = ret;
	}
	return S_OK;
}
