// Reader.h : Declaration of the CReader

#pragma once
#include "resource.h"       // main symbols

#include "iCscReader_i.h"
#include "_IReaderEvents_CP.h"


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif


// CReader

class ATL_NO_VTABLE CReader :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CReader, &CLSID_Reader>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CReader>,
	public CProxy_IReaderEvents<CReader>,
	public IObjectWithSiteImpl<CReader>,
	public IDispatchImpl<IReader, &IID_IReader, &LIBID_iCscReaderLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IObjectSafetyImpl<CReader, INTERFACESAFE_FOR_UNTRUSTED_CALLER| INTERFACESAFE_FOR_UNTRUSTED_DATA>
{
public:
	CReader()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_READER)


BEGIN_COM_MAP(CReader)
	COM_INTERFACE_ENTRY(IReader)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IObjectWithSite)
	COM_INTERFACE_ENTRY(IObjectSafety)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CReader)
	CONNECTION_POINT_ENTRY(__uuidof(_IReaderEvents))
END_CONNECTION_POINT_MAP()
// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);


	DECLARE_PROTECT_FINAL_CONSTRUCT()
	HRESULT FinalConstruct();
	void FinalRelease();

public:

	STDMETHOD(DoReader)(ULONG opcode,VARIANT p, LONG* retval);
};

OBJECT_ENTRY_AUTO(__uuidof(Reader), CReader)
